#include <iostream>
#include "glut.h"
#include "glext.h" 
using namespace std;


class Iluminacao
{
private:

protected:
 
public:   
Iluminacao(){}
~Iluminacao(){}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
void create(void)  
{
//CONFIGURACOES GERAIS
glEnable(GL_COLOR_MATERIAL);
glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
glLightModeli (GL_LIGHT_MODEL_COLOR_CONTROL,GL_SEPARATE_SPECULAR_COLOR); //Iluminao Sobre Texturas
  
  
/**************
/*LUZ DEFAULT
/**************/  
//VARIAVEIS
GLfloat diffuse_light1[] = { 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat position_light1[] = { 50.0f, 1.0f, 50.0f, 1.0f };
GLfloat especular_light1[] = { 0.1f, 0.1f, 0.1f, 1.0f };
GLfloat ambient1[]=  { 0.3f, 0.3f, 0.3f, 1.0f };
GLfloat constantAttenuation_light1= 0.4f;  

//CONFIGURAES
glLightfv( GL_LIGHT1, GL_DIFFUSE, diffuse_light1 );
glLightfv( GL_LIGHT1, GL_POSITION, position_light1 );
glLightf ( GL_LIGHT1, GL_CONSTANT_ATTENUATION, constantAttenuation_light1 );
glLightfv( GL_LIGHT1, GL_SPECULAR, especular_light1);    
glLightfv( GL_LIGHT1, GL_AMBIENT, ambient1);   
  
/**************
/*LUZ SPOT
/**************/  
//VARIAVEIS
GLfloat diffuse_light2[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat position_light2[] = { 0.0f, 0.0f, 1.0f, 0.0f };
GLfloat spotDirection_light2[] = { 0, 0, -1 };
GLfloat especular_light2[] = { 0.5, 0.5f, 0.5f, 1.0f };
GLfloat constantAttenuation_light2=0.7f; 	

//CONFIGURAES
glLightfv( GL_LIGHT2, GL_DIFFUSE, diffuse_light2 );
glLightfv( GL_LIGHT2, GL_POSITION, position_light2 );
glLightfv( GL_LIGHT2, GL_SPOT_DIRECTION, spotDirection_light2 );
glLightf ( GL_LIGHT2, GL_CONSTANT_ATTENUATION, constantAttenuation_light2 );
glLightf ( GL_LIGHT2, GL_SPOT_CUTOFF, 45.0f );
glLightf ( GL_LIGHT2, GL_SPOT_EXPONENT, 120.0f );
glLightfv(GL_LIGHT2, GL_SPECULAR, especular_light2);

/**************
/*LUZ AMBIENTE
/**************/  
//VARIAVEIS
GLfloat ambientlight[] = { 0.25f, 0.25f, 0.25f, 1.0f };

//CONFIGURAES
glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambientlight);     


}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
void set_material(char *shader_type)
{         
float mat_cor_blinn[]    = { 1.0, 1.0, 1.0, 1.0 };                    
float mat_cor_lambert[] = { 0.2, 0.2, 0.2, 0.2 };
float mat_cor_default[] = { 0.8, 0.8, 0.8, 0.8 };

if (shader_type=="blinn")          //Shader Blin
    {    
    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 400);              
    glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, mat_cor_blinn);    
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_cor_blinn);    
    }
if (shader_type=="lambert")       //Shader Lambert
    {
    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 50);              
    glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, mat_cor_blinn); 
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_cor_lambert); 
    }
if (shader_type==NULL)            //Shader Default
    {
    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 50);               
    glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, mat_cor_default);   
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_cor_default);
    }   
}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 

};

   

