/**************
/Authors: Alex & Jess 
/Company: Unicamp
/**************/

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//BIBLIOTECAS
#include <windows.h> 
#include <math.h>
#include <time.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "glut.h"
#include "glext.h" 
#include "glaux.h"
#include "glm.c"


//CLASSES
#include "Iluminacao.cpp"





using namespace std;  


//CONSTANTES
#define largura 800                    //Dimenso da Janela
#define altura 600
#define velocidade_fullscreen 8     //Em pcs rpidos, usar 6 e 12

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS PRINCIPAIS
void init(void);
void display(void);
void reshape (int w, int h);

void valores_iniciais();



//VARIAVEIS PRINCIPAIS
float ratio;                           //Proporo de Largura X Altura

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE TECLADO
void keyboard_pressionar(int key,register int x,register int y);
void keyboard_soltar(int key,register int x,register int y);
void keyboard_normal(unsigned char key,register int x,register int y);
void mov_camera(int i);
void virar_camera(float ang);


//VARIAVEIS DO SISTEMA DE TECLADO
float angle=0.0, deltaAngle = 0.0;
float xx=0.0f, yy=5.0f, zz=50.0f;
float lx=0.0f, ly=0.0f, lz=-1.0f;
short deltaMove = 0;


//CONSTANTES




////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE MOUSE
void mouse_click(int button, int state, int x, int y);
void menu_click(int value);
void MoveMouse(int x, int y);


//VARIAVEIS DO SISTEMA DE MOUSE
enum 
    {
	BUTTON_LEFT = 0, 
    BUTTON_RIGHT,
    BUTTON_LEFT_TRANSLATE,
    };

int mButton = -1, mOldY, mOldX;


////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO LOADER
GLMmodel* drawmodel(char *string, char *type);

//VARIAVEIS DO LOADER
GLboolean clear = GL_TRUE;

GLMmodel* pmodel1 = NULL;
GLMmodel* pmodel2 = NULL;
GLMmodel* pmodel3 = NULL;
GLMmodel* pmodel4 = NULL;



////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//CRIANDO OBJETOS PARA OS SISTEMAS DESAJADOS
Iluminacao Light_System;


/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DA CATAPULTA//////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////
void Catapulta();

/////////////////////////////////VARIAVEIS//////////////////////////////////////

float ang_atirador = 0.0;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO MURO///////////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Muro();
void Colisao_muro();

/////////////////////////////////VARIAVEIS//////////////////////////////////////

float x_muro;
float y_muro = 0;
float z_muro = 0;
float base_muro = 10;
float altura_muro = 10;

int acertos = 0;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO PROJETIL///////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Projetil();
void MovimentoCircular();
void MovimentoProjetil();

/////////////////////////////////VARIAVEIS//////////////////////////////////////
int projetil = 1;

float massa_projetil_A = 2;
float massa_projetil_B = 3;
float massa_projetil_C = 5;


float  x_inicial = 10.35;
float  y_inicial = 0;
float  z_inicial = 0;

float  x_circ_final = 0;
float  y_circ_final = 0;
float  z_circ_final = 0;

float  x_projetil = x_inicial;
float  y_projetil = y_inicial;
float  z_projetil = z_inicial; 

float  h_final = -0.01;

float  Forca = 35;
float  massa = massa_projetil_A;
 
float  ang_disparo = 45;
float  raio = x_inicial;

float  aceleracao = 0;
float  aceleracao_ang = 0;
float  velocidade = 0;
float  vel_vert = 0;
float  vel_horiz = 0;
float  Delta_ang = 0;
float  tempo_inicial =  0;
float  Delta_tempo = 0;

float  ang_proj = 0;
 
 
bool   mov_circ  = false;
bool   mov_proj  = false;
bool   disparar  = false;
bool   carregar = true;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM//
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
int main(int argc, char** argv){
cout<<"Iniando Console... ";

glutInit(&argc, argv);                                      //Caminho do arquivo
glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA); //Modo de vizualizao
glutInitWindowSize (largura, altura);                              //Tamanho da janela
glutInitWindowPosition (100, 100);                          //Posio da janela
if(!glutCreateWindow("NOME DO JOGO"))                     //Criar janela
    {
    MessageBox(NULL,"Falha ao criar janela.","Erro Fatal",MB_OK|MB_ICONERROR );
    return 0;
    exit(-1);
    }                                 

init ();                                                    //Inicializao principal

glutIgnoreKeyRepeat(1);                                     //Sistema de teclado
glutKeyboardFunc(keyboard_normal);
glutSpecialFunc(keyboard_pressionar);                                  
glutSpecialUpFunc(keyboard_soltar);                                

glutDisplayFunc(display);                                   //Desenho (Render)

glutIdleFunc(display);                                      //Funo callback de Render
glutReshapeFunc(reshape);                                   //Redimensionar Janela
glutMainLoop();                                             //Loop principal

return TRUE;
}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void init(void)
{    
//MODELOS
cout<<"(OK)\nCarregando modelos 3D... ";  

pmodel1=drawmodel("models/Catapulta_Base.obj","texture");
pmodel2=drawmodel("models/Atirador.obj","texture");
pmodel3=drawmodel("models/Pedra.obj","texture");
pmodel4=drawmodel("models/Roda_Composta.obj","texture");

//INICIANDO CONFIGURACOES PADROES
cout<<" (OK)\nDefinindo configuracoes iniciais... ";  

glClearColor (0, 0, 0, 0);                  //Cor de fundo
valores_iniciais();

cout<<"(OK)";  

}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void display(void)
{ 	     


if (deltaMove)
	mov_camera(deltaMove);
if (deltaAngle) 
    {
	angle += deltaAngle;
	virar_camera(angle);
	}
 
/***************
/CFG INICIAL
/***************/
glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        //Limpando buffers


glEnable(GL_DEPTH_TEST); //TESTA PROFUNDIDADE P/ EXIBIR SEM SOBREPOSICAO
glShadeModel(GL_SMOOTH); //SECIONA O TIPO DE SHADER. EX: GL_FLAT


glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);


Catapulta();

if(acertos<3)
  Muro();

glColor3f(0,1,0); 

glBegin(GL_POLYGON); 
        glVertex3f(-400,0,-400);
        glVertex3f(-400,0, 400);
        glVertex3f( 400,0, 400);
        glVertex3f( 400,0,-400); 
glEnd(); 

if(acertos<3)
   Colisao_muro();

glFlush();			  
glutSwapBuffers();  
 
}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void reshape (int w, int h)
{
  	if(h == 0)                       
		h = 1;

	ratio = 1.0f * w / h;
	
	glMatrixMode(GL_PROJECTION);     
	glLoadIdentity();
	glClearColor (0, 0, 0, 0);  
    glViewport(0, 0, w, h);          
	gluPerspective(45,ratio,0,2000);                  
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); 
    
    
    glMatrixMode(GL_MODELVIEW);    
	glLoadIdentity();
	gluLookAt(xx,      yy,      zz,   
		      xx + lx, yy + ly, zz + lz,
			  0.0f,   1.0f,   0.0f);
			  
                
}  


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//TECLADO
void keyboard_pressionar(int key,register int x,register int y) {


	switch (key) 
    {
       
		case GLUT_KEY_LEFT : deltaAngle = -0.045f;
        break;
		
        case GLUT_KEY_RIGHT : deltaAngle = 0.045f;
        break;
		
        case GLUT_KEY_UP : 

            deltaMove = velocidade_fullscreen;
      
        break;
		
        case GLUT_KEY_DOWN :
    
            deltaMove = -velocidade_fullscreen;
        
        break;

   }



}

void keyboard_soltar(int key,register int x,register int y) 
{
     
	switch (key) 
    {
		case GLUT_KEY_LEFT : 
		case GLUT_KEY_RIGHT : deltaAngle = 0.0f;
        break;	
        
		case GLUT_KEY_UP : 
		case GLUT_KEY_DOWN : deltaMove = 0;
        break;
	}

}

void keyboard_normal(unsigned char key,register int x,register int y) 
{

	switch (key) 
    {
		case 'r' :        
		case 'R' : 
	             carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 x_projetil = x_inicial;
                 y_projetil = y_inicial;
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;
                 
                 acertos = 0;
                 
                 valores_iniciais();
	         
        break;
        
        case 'd' : 
        case 'D' :
             if (carregar){
	            disparar  = true;
	            carregar = false;
             }
        break;
        
        
        case 'c' : 
        case 'C' :
             if (disparar && mov_circ && mov_proj){
                 carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 x_projetil = x_inicial;
                 y_projetil = y_inicial;
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;
                 
                 
                 
             }
        break;
        
        case 'A' :
             if (ang_disparo >= 0){
                 ang_disparo -= 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo maximo de disparo  de 90.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'a' : 
             if (ang_disparo < 90 ){
                 ang_disparo += 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo minimo de disparo  de 0.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'F' :
             if (Forca >= 10){
                 Forca -= 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora maxima de disparo  de 80N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'f' : 
             if (Forca < 90){
                 Forca += 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora minima de disparo  de 10N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case '1' : 
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 1;
                  massa = massa_projetil_A;
                  cout<<"\nProjetil A selecionado. Massa do Projetil: " << massa; 
             }
        break;
        
        case '2' : 
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 2;
                  massa = massa_projetil_B;
                  cout<<"\nProjetil B selecionado. Massa do Projetil: " << massa; 
             }
        break;
        
        case '3' : 
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 3;
                  massa = massa_projetil_C;
                  cout<<"\nProjetil C selecionado. Massa do Projetil: " << massa; 
             }
        break;
        
        case 27 : 
             exit(0);
        break;
        
	}

}   


////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
void virar_camera(float ang) 
{

lx = sin(ang);
lz = -cos(ang);
glLoadIdentity();
gluLookAt(xx,     yy,     zz, 
		  xx + lx,yy + ly,zz + lz,
		  0.0f,  1.0f,  0.0f);
}


//////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////// 
void mov_camera(int i) 
{                   

xx = xx + (i*lx*0.1);
zz = zz + (i*lz*0.1);


glLoadIdentity();  

gluLookAt(xx     ,yy     ,zz, 
		      xx + lx, yy + ly, zz + lz,
		      0.0f   ,1.0f   ,0.0f);
        

}   

 

     
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////         
GLMmodel* drawmodel(char *string, char *type)
{
    GLMmodel* pmodel = NULL;
    if (!pmodel) {
        pmodel = glmReadOBJ(string);
        if (!pmodel) exit(0);
        glmFacetNormals(pmodel);
        glmVertexNormals(pmodel, 0);
    }    

return pmodel;
}




//****************************************************************************//
//////////////////////////Catapulta/////////////////////////////////////////////

void Catapulta(){

float fator = 2;

glPushMatrix(); 
    
    glEnable( GL_LIGHT1 ); 
     
    glPushMatrix(); 
       glColor3f(1,.5,1);
       glScalef(fator,fator,fator);
       glTranslatef(-3.25,-0.7,2.5);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    glPushMatrix(); 
       glColor3f(1,.5,1);
       glScalef(fator,fator,fator);
       glTranslatef(3.25,-0.7,2.5);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    
    
    glPushMatrix(); 
       glColor3f(1,0,0);
       glScalef(fator,fator,fator);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix(); 
    
    
    glPushMatrix();
        glColor3f(1,1,0); 
        glScalef(fator,fator,fator);
        glRotatef(ang_atirador,0,0,1);
	    glmDraw(pmodel2, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();   

      
    Projetil(); 
    
    glPushMatrix(); 
       glColor3f(1,.5,1);
       glScalef(fator,fator,fator);
       glTranslatef(-3.25,-0.7,-2.5);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    
    glPushMatrix(); 
       glColor3f(1,.5,1);
       glScalef(fator,fator,fator);
       glTranslatef(3.25,-0.7,-2.5);
	   glmDraw(pmodel4, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix();
    

glPopMatrix(); 
     
}

//****************************************************************************//
/////////////////////////////////////PROJETIL///////////////////////////////////

void Projetil(){     
glPushMatrix();

    if(disparar && !mov_circ){
         MovimentoCircular();
    }
    
    if(disparar && mov_circ && !mov_proj){
          MovimentoProjetil();
    }
    
    
    glTranslatef(x_projetil,y_projetil,z_projetil);
    
    if(!mov_proj && mov_circ)
          ang_proj += 2;
    glRotatef(ang_proj,1,1,1);
    
    
    	switch (projetil) 
    {
		case 1: 
              glScalef(.5,.5,.5);
		      glColor3f(0,0,1);
              glutSolidSphere(1, 10, 10);
        break;	
        
		case 2: 
              glScalef(.5,.8,.65);
		      glColor3f(0,1,1);
              glutSolidSphere(1, 10, 10);
        break;
        
        case 3: 
              glScalef(.8,.8,.8);
		      glColor3f(1,0,1);
		      glutSolidSphere(1, 10, 10);              
        break;
	}
    

glPopMatrix();
     
};


void MovimentoCircular(){
  
  if( Delta_ang <= (ang_disparo*M_PI/180)){  
      
      aceleracao = Forca * massa;
      aceleracao_ang = aceleracao/raio;
      
      if(tempo_inicial == 0){
            tempo_inicial = timeGetTime ();      
      }
      Delta_tempo = timeGetTime() - tempo_inicial;
      
      Delta_tempo = Delta_tempo / 500;
      
      Delta_ang = (aceleracao_ang * Delta_tempo * Delta_tempo)/2;
 
      x_projetil = cos(Delta_ang) * raio;
      y_projetil = sin(Delta_ang) * raio + y_inicial;
      
      ang_atirador = Delta_ang / M_PI * 180;
      
   }else {
          mov_circ = true;  
          
          x_circ_final = x_projetil;
          y_circ_final = y_projetil;
          z_circ_final = z_projetil;
          
          velocidade  = aceleracao*(sqrt(2*(ang_disparo*M_PI/180)/aceleracao_ang)); 
          vel_horiz =  cos((90-ang_disparo)*M_PI/180) * velocidade;
          vel_vert  =  sin((90-ang_disparo)*M_PI/180) * velocidade;
          
          tempo_inicial = 0;           
   }
};

void MovimentoProjetil(){
      
      if(y_projetil >= h_final && !mov_proj){  
      
          if(tempo_inicial == 0){
              tempo_inicial = timeGetTime ();      
          }
          Delta_tempo = timeGetTime() - tempo_inicial;
          
          Delta_tempo = Delta_tempo / 500;
          
          x_projetil = x_circ_final - ( vel_horiz * Delta_tempo );
          
          y_projetil = y_circ_final + ( vel_vert * Delta_tempo ) + ( -9.8 * (Delta_tempo * Delta_tempo) / 2 );
          
      }else {
          mov_proj = true;
      }
};

//****************************************************************************//
/////////////////////////////////////Muro///////////////////////////////////////
void Muro(){
     
glPushMatrix();        
     
     glTranslatef(x_muro,y_muro,z_muro);
     glScalef(1,1,2);
     glColor3f(1,1,1);
     for (int i = 1;i<=altura_muro;i++){
         
         for (int j = 1; j<=base_muro;j++){
            glPushMatrix(); 
                glTranslatef(0,i,(base_muro/2)-j);      
                glutSolidCube(1); 
            glPopMatrix();     
         };  
         
     }
     

     
glPopMatrix();
};

void Colisao_muro(){
     if(x_projetil >= (x_muro-.5) && x_projetil <= (x_muro+.5)&& !mov_proj){
                 
            if (y_projetil <= altura_muro){   
 
                      acertos++; 
                      cout<<"\n\nVoce acertou o muro, voce acertou "<< acertos<<" vezes.\n";    
                      if(acertos>=3)
                        cout<<"\n\nMuro destroido.\n";  
                      else{
                           mov_circ = true; 
                           mov_proj = true; 
                      }
            }
                 
     }
}

void valores_iniciais(){


     x_muro = -100-(int)timeGetTime()%100;
     Forca = 80 - (int)timeGetTime()%70;
     ang_disparo = 90 - (int)timeGetTime()%70;
     
     cout<<"\nAngulo: "<<ang_disparo;
     cout<<"\nFora: "<<Forca;
     cout<<"\nMuro: "<<x_muro;
};


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

